#include <windows.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>	
#include <time.h>
HDC	hDC=NULL;  
HGLRC hRC=NULL;     
HWND hWnd=NULL;    


HINSTANCE hInstance;

bool keys[256];      
bool active=TRUE;    
bool fullscreen=TRUE;

int kierunek=0;

#define rob_count 5
#define liczba_trafien 3

GLfloat lmodel_ambient[] = { 1, 1, 1, 1 };

GLfloat light_ambient0[] = { 0.0, 30.0, 0.0, 1.0 };
GLfloat spot_direction0[] = { 0.0, -1.0, 0.0 };

GLfloat light_ambient1[] = { 5.0, 3.0, 2.0, 1.0 };
GLfloat spot_direction1[] = { 0.0, -1.0, 0.0 };

GLfloat light_ambient2[] = { 30.0, 0.0, 0.0, 10.0 };
GLfloat spot_direction2[] = { 0.0, -1.0, 0.0 };
GLfloat light_ambient3[] = { 30.0, 0.0, 0.0, 10.0 };
GLfloat spot_direction3[] = { 0.0, -1.0, 0.0 };

GLfloat light_ambient4[] = { 3.0f, 3.0f, 3.0f, 3.0f };
GLfloat spot_direction4[] = { 0.0, -1.0, 0.0 };

GLfloat light_ambient5[] = { 0.0f, 0.0f, 30.0f, 3.0f };
GLfloat spot_direction5[] = { 0.0, -1.0, 0.0 };

GLfloat light_ambient6[] = { 0.0f, 0.0f, 30.0f, 3.0f };
GLfloat spot_direction6[] = { 0.0, -1.0, 0.0 };

GLfloat light_ambient7[] = { 10.0f, 5.0f, 12.0f, 3.0f };
GLfloat spot_direction7[] = { 0.0, -1.0, 0.0 };


GLfloat kolor_mgly[] = { 0.0f, 0.0f, 0.0f, 0.0f };

const float piover180 = 0.0174532925f;
float direction=180;
float xpos=2;	   
float zpos=2;
float x_temp=0;		   
float z_temp=0;

bool w_powietrzu;
GLfloat trajektoria,xpoc,zpoc;
GLfloat rob_direction[rob_count];
GLfloat xrob[rob_count];
GLfloat zrob[rob_count];
int health[rob_count];
GLUquadricObj *quad;	     
int trafiony_robot;

GLint robot;
GLint naboj3;
GLint gun;

const walls_count=22;
struct {
	float x1;
	float x2;
	float z1;
	float z2; }  wall[walls_count],podloga;

GLuint	texture[12];//tablica do przechowywania tekstur

AUX_RGBImageRec *LoadBMP(char *Filename) //wgranie obrazu
{
FILE *File=NULL;
if (!Filename)		//zapobiegamy wgraniu nie istniejacego pliku
{
return NULL;
}
File=fopen(Filename,"r");	
if (File)				
{
fclose(File);					
return auxDIBImageLoad(Filename);
}
return NULL;
};

int LoadGLTextures()	
{
	int Status=FALSE;	

	AUX_RGBImageRec *TextureImage[7];

	memset(TextureImage,0,sizeof(void *)*7);

	if ((TextureImage[0]=LoadBMP("textures/brick.bmp"))&&
		(TextureImage[1]=LoadBMP("textures/deska.bmp"))&&
		(TextureImage[2]=LoadBMP("textures/panel.bmp")) &&
		(TextureImage[3]=LoadBMP("textures/niebieski.bmp")) &&
		(TextureImage[4]=LoadBMP("textures/qq.bmp")) &&
		(TextureImage[5]=LoadBMP("textures/robot.bmp")) &&
		(TextureImage[6]=LoadBMP("textures/plasma.bmp")) 

		)
	{
		Status=TRUE;		

		glGenTextures(12, &texture[0]);	

		//
		for(int i=0;i<7;i++)
		{
			glBindTexture(GL_TEXTURE_2D, texture[i]);
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[i]->sizeX, TextureImage[i]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[i]->data);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		}
		for(i=0;i<7;i++)
		{
			if (TextureImage[i])			
			{
				if (TextureImage[i]->data)	
				{
					free(TextureImage[i]->data);
				}
				free(TextureImage[i]);
			}
		}
	}
	return Status;	
}

GLUquadricObj *quadratic;

void draw_wall(GLfloat x1,GLfloat z1,GLfloat x2,GLfloat z2)
{
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	glBegin(GL_QUADS);  
	glTexCoord2f(0.0f, 0.0f);glVertex3f(x1, 0, z1);
	glTexCoord2f(1.0f, 0.0f);glVertex3f(x2, 0, z2);
	glTexCoord2f(1.0f, 1.0f);glVertex3f(x2, 1.5f, z2);
	glTexCoord2f(0.0f, 1.0f);glVertex3f(x1, 1.5f, z1);
	glEnd();
}

void draw_floor(GLfloat x1,GLfloat z1,GLfloat x2,GLfloat z2)
{	
	glBindTexture(GL_TEXTURE_2D, texture[1]);
	glBegin(GL_QUADS);
	glTexCoord2f(0.0f, 0.0f);glVertex3f(x1, 0.0f, z1);
	glTexCoord2f(1.0f, 0.0f);glVertex3f(x1, 0.0f, z2);
	glTexCoord2f(1.0f, 1.0f);glVertex3f(x2, 0.0f, z2);
	glTexCoord2f(0.0f, 1.0f);glVertex3f(x2, 0.0f, z1);
	glEnd();
}

void draw_ceiling(GLfloat x1,GLfloat z1,GLfloat x2,GLfloat z2)
{	
	glBindTexture(GL_TEXTURE_2D, texture[2]);
	glBegin(GL_QUADS);
	glTexCoord2f(0.0f, 0.0f);glVertex3f(x1, 1.5f, z1);
	glTexCoord2f(1.0f, 0.0f);glVertex3f(x1, 1.5f, z2);
	glTexCoord2f(1.0f, 1.0f);glVertex3f(x2, 1.5f, z2);
	glTexCoord2f(0.0f, 1.0f);glVertex3f(x2, 1.5f, z1);
	glEnd();
}

void bron(GLfloat xpos, GLfloat zpos)
{
	glBindTexture(GL_TEXTURE_2D, texture[3]);
	glTranslatef(xpos-(float)sin(direction*piover180)*0.1f,0.35f,zpos-(float)cos(direction*piover180) * 0.1f);
	glRotatef(direction+180,0,1,0);
	glCallList(gun);
	
}

bool czy_koniec() {
	for(int i=0;i<rob_count;i++)
		if(health[i]>0) return false;
	return true;	
}

bool sprawdz(float x_temp,float z_temp,int nr_robota=0) //czy nie ma kolizji
{
	float x_min,x_max,z_min,z_max;
	int i;
	for(i=0;i<walls_count;i++) {

		if (wall[i].x1==wall[i].x2) {
			if(wall[i].z1<wall[i].z2) { 
				z_min=wall[i].z1;
				z_max=wall[i].z2;
			}
			else {
				z_min=wall[i].z2;
				z_max=wall[i].z1;
			}
			if(x_temp<(wall[i].x1+0.3)&&x_temp>(wall[i].x1-0.3)&&z_temp>(z_min-0.3)&&z_temp<(z_max+0.3))
				return false;
		}
		else {
			if(wall[i].x1<wall[i].x2) { 
				x_min=wall[i].x1;
				x_max=wall[i].x2;
			}
			else {
				x_min=wall[i].x2;
				x_max=wall[i].x1;
			}
			if(z_temp<(wall[i].z1+0.3)&&z_temp>(wall[i].z1-0.3)&&x_temp>x_min&&x_temp<x_max)
				return false;
		}
	}
	
	for(i=0;i<rob_count;i++) {
		if(i+1!=nr_robota)
		if((x_temp>(xrob[i]-0.6))&&(x_temp<(xrob[i]+0.6))&&(z_temp>(zrob[i]-0.6))&&(z_temp<(zrob[i]+0.6)))
		{
			if(nr_robota==100) health[i]--;
			return false;
		}
	if(nr_robota>0&&nr_robota<=rob_count)
		if((x_temp>(xpos-0.6))&&(x_temp<(xpos+0.6))&&(z_temp>(zpos-0.6))&&(z_temp<zpos+0.6)) 
			return false;
	}
	
return true;
}

void ruch_w_przod()
{
	x_temp -= (float)sin(direction*piover180) * 0.15f;
	z_temp -= (float)cos(direction*piover180) * 0.15f;
	if (sprawdz(x_temp,z_temp))
	{
		xpos=x_temp;
		zpos=z_temp;
	}
	else
	{
		x_temp=xpos;
		z_temp=zpos;
	}
}

void ruch_w_tyl()
{
    x_temp += (float)sin(direction*piover180) * 0.15f;
	z_temp += (float)cos(direction*piover180) * 0.15f;
	if (sprawdz(x_temp,z_temp))
	{
		xpos=x_temp;
		zpos=z_temp;
	}
	else
	{
	    x_temp=xpos;
		z_temp=zpos;
	}
}

void obrot_w_prawo()
{
    direction -= 3.0f;
}

void obrot_w_lewo()
{
    direction += 3.0f;
}

void ruch_robota(int i)
{
	if(health[i]>0) {
		if(rand()%30==0) {
			if(rand()%2) rob_direction[i]+=rand()%30;
			else rob_direction[i]-=rand()%30;
		}
		GLfloat xxx,zzz;
		xxx = xrob[i] - (float)sin((rob_direction[i])*piover180) * 0.1f;
		zzz = zrob[i] - (float)cos((rob_direction[i])*piover180) * 0.1f;
		if(sprawdz(xxx,zzz,i+1))
		{
			xrob[i]=xxx;
			zrob[i]=zzz;
			glBindTexture(GL_TEXTURE_2D, texture[6]);
			glTranslatef(xrob[i],0.3f,zrob[i]);
			glRotatef(180+rob_direction[i],0,1.0f,0);
			glCallList(robot);
		}
		else
		{
			if(rand()%2) rob_direction[i]+=rand()%30;
			else rob_direction[i]-=rand()%30;
	
			glBindTexture(GL_TEXTURE_2D, texture[6]);
			glTranslatef(xrob[i],0.3f,zrob[i]);
			glRotatef(180+rob_direction[i],0,1.0f,0);
			glCallList(robot);
		}	
	}
	else {
		glBindTexture(GL_TEXTURE_2D, texture[5]);
		glTranslatef(xrob[i],0.1f,zrob[i]);
		glRotatef(180+rob_direction[i],0,1,0);
		glRotatef(-90,1,0,0);
		glCallList(robot);
	}
}
	


void strzal()
{
	if(!w_powietrzu) {
		w_powietrzu=true;
		trajektoria=direction;
		xpoc = xpos - (float)sin((trajektoria)*piover180) * 0.2f;
		zpoc = zpos - (float)cos((trajektoria)*piover180) * 0.2f;
	}

}

void lot_pocisku()
{				  

	GLfloat xxx,zzz;
	if(w_powietrzu)
	{
		xxx = xpoc - (float)sin((trajektoria)*piover180) * 0.5f;
		zzz = zpoc - (float)cos((trajektoria)*piover180) * 0.5f;
		if(sprawdz(xxx,zzz,100))
		{
			xpoc=xxx;
			zpoc=zzz;
			glBindTexture(GL_TEXTURE_2D, texture[4]);
	
			glTranslatef(xxx,0.25f,zzz);
			glRotatef(180+trajektoria,0,1.0f,0);
			
			glCallList(naboj3);
	
		}
		else
		{
			xxx = xpoc - (float)sin((trajektoria)*piover180) * 0.27f;
			zzz = zpoc - (float)cos((trajektoria)*piover180) * 0.27f;
			w_powietrzu=false;

		}
	}
	else{}
}

void ustal_koordynaty()
{
	podloga.x1=0;
	podloga.x2=60;
	podloga.z1=0;
	podloga.z2=35;

wall[0].x1=0;
wall[0].x2=50;
wall[0].z1=0;
wall[0].z2=0;

wall[1].x1=0;
wall[1].x2=10;
wall[1].z1=20;
wall[1].z2=20;

wall[2].x1=0;
wall[2].x2=0;
wall[2].z1=0;
wall[2].z2=20;

wall[3].x1=10;
wall[3].x2=10;
wall[3].z1=5;
wall[3].z2=15;

wall[4].x1=10;
wall[4].x2=45;
wall[4].z1=15;
wall[4].z2=15;

wall[5].x1=50;
wall[5].x2=50;
wall[5].z1=0;
wall[5].z2=20;

wall[6].x1=30;
wall[6].x2=50;
wall[6].z1=35;
wall[6].z2=35;

wall[7].x1=30;
wall[7].x2=30;
wall[7].z1=20;
wall[7].z2=25;

wall[8].x1=15;
wall[8].x2=30;
wall[8].z1=20;
wall[8].z2=20;

wall[9].x1=10;
wall[9].x2=10;
wall[9].z1=20;
wall[9].z2=35;

wall[10].x1=15;
wall[10].x2=15;
wall[10].z1=20;
wall[10].z2=25;

wall[11].x1=15;
wall[11].x2=30;
wall[11].z1=25;
wall[11].z2=25;

wall[12].x1=25;
wall[12].x2=30;
wall[12].z1=30;
wall[12].z2=30;

wall[13].x1=25;
wall[13].x2=25;
wall[13].z1=30;
wall[13].z2=35;

wall[14].x1=10;
wall[14].x2=25;
wall[14].z1=35;
wall[14].z2=35;

wall[15].x1=30;
wall[15].x2=30;
wall[15].z1=30;
wall[15].z2=35;

wall[16].x1=40;
wall[16].x2=40;
wall[16].z1=20;
wall[16].z2=35;

wall[17].x1=30;
wall[17].x2=45;
wall[17].z1=10;
wall[17].z2=10;

wall[18].x1=40;
wall[18].x2=50;
wall[18].z1=20;
wall[18].z2=20;

wall[19].x1=45;
wall[19].x2=45;
wall[19].z1=10;
wall[19].z2=15;

wall[20].x1=30;
wall[20].x2=30;
wall[20].z1=5;
wall[20].z2=10;

wall[21].x1=10;
wall[21].x2=30;
wall[21].z1=5;
wall[21].z2=5;
}

int InitGL(GLvoid)
{       
    if (!LoadGLTextures())
	{
		return FALSE;
    }
	glEnable(GL_TEXTURE_2D);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glClearDepth(1.0);
	glDepthFunc(GL_LESS);	
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

	ustal_koordynaty();
	
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT,lmodel_ambient);
	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient0);
	glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, spot_direction0);
	glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, 65.0);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT1, GL_AMBIENT, light_ambient1);
	glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, spot_direction1);
	glLightf(GL_LIGHT1, GL_SPOT_CUTOFF, 75.0);
	glEnable(GL_LIGHT1);
	glLightfv(GL_LIGHT2, GL_AMBIENT, light_ambient2);
	glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, spot_direction2);
	glLightf(GL_LIGHT2, GL_SPOT_CUTOFF, 75.0);
	glEnable(GL_LIGHT2);
	glLightfv(GL_LIGHT3, GL_AMBIENT, light_ambient3);
	glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, spot_direction3);
	glLightf(GL_LIGHT3, GL_SPOT_CUTOFF, 75.0);
	glEnable(GL_LIGHT3);
	glLightfv(GL_LIGHT4, GL_AMBIENT, light_ambient4);
	glLightfv(GL_LIGHT4, GL_SPOT_DIRECTION, spot_direction4);
	glLightf(GL_LIGHT4, GL_SPOT_CUTOFF, 60.0);
	glEnable(GL_LIGHT4);
	glLightfv(GL_LIGHT5, GL_AMBIENT, light_ambient5);
	glLightfv(GL_LIGHT5, GL_SPOT_DIRECTION, spot_direction5);
	glLightf(GL_LIGHT5, GL_SPOT_CUTOFF, 80.0);
	glEnable(GL_LIGHT5);
	glLightfv(GL_LIGHT6, GL_AMBIENT, light_ambient6);
	glLightfv(GL_LIGHT6, GL_SPOT_DIRECTION, spot_direction6);
	glLightf(GL_LIGHT6, GL_SPOT_CUTOFF, 80.0);
	glEnable(GL_LIGHT6);
	glLightfv(GL_LIGHT7, GL_AMBIENT, light_ambient7);
	glLightfv(GL_LIGHT7, GL_SPOT_DIRECTION, spot_direction7);
	glLightf(GL_LIGHT7, GL_SPOT_CUTOFF, 75.0);
	glEnable(GL_LIGHT7);

	glEnable(GL_LIGHTING);
	quadratic=gluNewQuadric(); 
	quad=gluNewQuadric(); 
	gluQuadricNormals(quadratic, GL_SMOOTH);
	gluQuadricTexture(quadratic, GL_TRUE);
	gluQuadricNormals(quad, GL_SMOOTH);
	gluQuadricTexture(quad, GL_TRUE);
	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);	

	glFogf(GL_FOG_MODE, GL_LINEAR);
	glFogfv(GL_FOG_COLOR, kolor_mgly );
	glFogf(GL_FOG_DENSITY, 2.0f);	
	glHint(GL_FOG_HINT, GL_NICEST);	
	glFogf(GL_FOG_START, 0.10f);
	glFogf(GL_FOG_END, 5.0f);
	return TRUE;	
}

int DrawGLScene(GLvoid)
{
	int i,j;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
    
	GLfloat move_to_x = -xpos;
	GLfloat move_to_z = -zpos;
	GLfloat move_to_y = -0.45f;
	GLfloat obrot_sceny = 360.0f - direction;

    glPushMatrix();
			GLfloat light_position0[] = { move_to_x+1.0f, move_to_y+0.8f, move_to_z+19.0f, 1.0 };
            GLfloat light_position1[] = { move_to_x+11.0f, move_to_y+0.75f, move_to_z+34.0f, 1.0 };
			GLfloat light_position2[] = { move_to_x+12.0f, move_to_y+0.90f, move_to_z+2.0f, 1.0 };
			GLfloat light_position3[] = { move_to_x+12.0f, move_to_y+0.90f, move_to_z+16.0f, 1.0 };
			GLfloat light_position4[] = { move_to_x+xpos, move_to_y+0.75f, move_to_z+zpos, 1.0 };
			GLfloat light_position5[] = { move_to_x+31.0f, move_to_y+0.8f, move_to_z+9.0f, 1.0 };
            GLfloat light_position6[] = { move_to_x+49.0f, move_to_y+0.75f, move_to_z+2.0f, 1.0 };
			GLfloat light_position7[] = { move_to_x+49.0f, move_to_y+0.90f, move_to_z+19.0f, 1.0 };
			
			glRotatef(obrot_sceny,0,1.0f,0);
			glLightfv(GL_LIGHT0, GL_POSITION, light_position0);
			glLightfv(GL_LIGHT1, GL_POSITION, light_position1);
			glLightfv(GL_LIGHT2, GL_POSITION, light_position2);
			glLightfv(GL_LIGHT3, GL_POSITION, light_position3);
			glLightfv(GL_LIGHT4, GL_POSITION, light_position4);
			glLightfv(GL_LIGHT5, GL_POSITION, light_position5);
			glLightfv(GL_LIGHT6, GL_POSITION, light_position6);
			glLightfv(GL_LIGHT7, GL_POSITION, light_position7);

			glPopMatrix();
	
	glRotatef(obrot_sceny,0,1.0f,0);
	glTranslatef(move_to_x, move_to_y, move_to_z);
	
	for(i=0;i<walls_count;i++)
	{
		if(wall[i].x1<wall[i].x2)
			for(int j=0;j<wall[i].x2-wall[i].x1;j++)
				draw_wall(wall[i].x1+j,wall[i].z1,wall[i].x1+j+1,wall[i].z2);
		else
		if(wall[i].x1>wall[i].x2)
			for(int j=0;j<wall[i].x1-wall[i].x2;j++)
				draw_wall(wall[i].x2+j,wall[i].z1,wall[i].x2+j+1,wall[i].z2);
		else
			if(wall[i].z1<wall[i].z2)
				for(int k=0;k<wall[i].z2-wall[i].z1;k++)
					draw_wall(wall[i].x1,wall[i].z1+k,wall[i].x1,wall[i].z1+k+1);
			else
			if(wall[i].z1>wall[i].z2)
				for(int k=0;k<wall[i].z1-wall[i].z2;k++)
					draw_wall(wall[i].x1,wall[i].z2+k,wall[i].x1,wall[i].z2+k+1);
				
	};
	
    for(i=(int)podloga.x1;i<podloga.x2;i++)
		for(j=(int)podloga.z1;j<podloga.z2;j++) {
			draw_floor((float)i,(float)j,(float)(i+1),(float)(j+1));
			draw_ceiling((float)i,(float)j,(float)(i+1),(float)(j+1));
		}
	glPushMatrix();
	lot_pocisku();
	glPopMatrix();
	
	for(i=0;i<rob_count;i++) {
		glPushMatrix();
		ruch_robota(i);
		glPopMatrix();
	}

	glPushMatrix();
	bron(xpos,zpos);
	glPopMatrix();

	return TRUE;									
}

void prostopadloscian(float x1,float y1,float z1,float x2,float y2,float z2,
              float x3,float y3,float z3,float x4,float y4,float z4,
              float x5,float y5,float z5,float x6,float y6,float z6,
              float x7,float y7,float z7,float x8,float y8,float z8)
{
  glBegin(GL_QUADS);

  glTexCoord2f(0.0f, 0.0f);
  glVertex3f(x1,y1,z1);
  glTexCoord2f(1.0f, 0.0f);
  glVertex3f(x2,y2,z2);
  glTexCoord2f(1.0f, 1.0f);
  glVertex3f(x3,y3,z3);
  glTexCoord2f(0.0f, 1.0f);
  glVertex3f(x4,y4,z4);

  glTexCoord2f(0.0f, 0.0f);
  glVertex3f(x1,y1,z1);
  glTexCoord2f(1.0f, 0.0f);
  glVertex3f(x2,y2,z2);
  glTexCoord2f(1.0f, 1.0f);
  glVertex3f(x6,y6,z6);
  glTexCoord2f(0.0f, 1.0f);
  glVertex3f(x5,y5,z5);

  glTexCoord2f(0.0f, 0.0f);
  glVertex3f(x1,y1,z1);
  glTexCoord2f(1.0f, 0.0f);
  glVertex3f(x4,y4,z4);
  glTexCoord2f(1.0f, 1.0f);
  glVertex3f(x8,y8,z8);
  glTexCoord2f(0.0f, 1.0f);
  glVertex3f(x5,y5,z5);

  glTexCoord2f(0.0f, 0.0f);
  glVertex3f(x2,y2,z2);
  glTexCoord2f(1.0f, 0.0f);
  glVertex3f(x3,y3,z3);
  glTexCoord2f(1.0f, 1.0f);
  glVertex3f(x7,y7,z7);
  glTexCoord2f(0.0f, 1.0f);
  glVertex3f(x6,y6,z6);

  glTexCoord2f(0.0f, 0.0f);
  glVertex3f(x3,y3,z3);
  glTexCoord2f(1.0f, 0.0f);
  glVertex3f(x4,y4,z4);
  glTexCoord2f(1.0f, 1.0f);
  glVertex3f(x8,y8,z8);
  glTexCoord2f(0.0f, 1.0f);
  glVertex3f(x7,y7,z7);

  glTexCoord2f(0.0f, 0.0f);
  glVertex3f(x5,y5,z5);
  glTexCoord2f(1.0f, 0.0f);
  glVertex3f(x6,y6,z6);
  glTexCoord2f(1.0f, 1.0f);
  glVertex3f(x7,y7,z7);
  glTexCoord2f(0.0f, 1.0f);
  glVertex3f(x8,y8,z8);


  glEnd();
}

void przygotuj(void) {

  robot = glGenLists(1);
 glNewList(robot, GL_COMPILE);
  glScalef(0.1f,0.1f,0.1f);
 //glowa
 glPushMatrix();
 glTranslatef(0,3,0);
 GLUquadricObj* obj10;
 obj10=gluNewQuadric();
 gluSphere(obj10,1.5,20,20);
 glPopMatrix();
 //oczy
 glPushMatrix();
 glTranslatef(0.5f,3.5f,1.3f);
 gluSphere(obj10,0.2,20,20);
 glTranslatef(-1,0,0);
 gluSphere(obj10,0.2,20,20);
 glPopMatrix();
 //tulow
 prostopadloscian(-1.5,-1,1,1.5,-1,1,1.5,-1,-1,-1.5,-1,-1,
          -1.5,2,1,1.5,2,1,1.5,2,-1,-1.5,2,-1);
 // lewa noga
 glTranslatef(-1,-3.5,0);
 prostopadloscian(-0.5,-1,0.5,0.5,-1,0.5,0.5,-1,-0.5,-0.5,-1,-0.5,
          -0.5,2.5,0.5,0.5,2.5,0.5,0.5,2.5,-0.5,-0.5,2.5,-0.5);
 //prawa noga
 glTranslatef(2,0,0);
 prostopadloscian(-0.5,-1,0.5,0.5,-1,0.5,0.5,-1,-0.5,-0.5,-1,-0.5,
          -0.5,2.5,0.5,0.5,2.5,0.5,0.5,2.5,-0.5,-0.5,2.5,-0.5);
 //lewa reka
 glTranslatef(-2.5,4,0);
 prostopadloscian(-0.5,-0.5,2.5,0.5,-0.5,2.5,0.5,-0.5,-0.5,-0.5,-0.5,-0.5,
          -0.5,0.5,2.5,0.5,0.5,2.5,0.5,0.5,-0.5,-0.5,0.5,-0.5);
 //prawa reka
 glTranslatef(3,0,0);
 prostopadloscian(-0.5,-0.5,2.5,0.5,-0.5,2.5,0.5,-0.5,-0.5,-0.5,-0.5,-0.5,
          -0.5,0.5,2.5,0.5,0.5,2.5,0.5,0.5,-0.5,-0.5,0.5,-0.5);

  glEndList();


  gun = glGenLists(1);
  glNewList(gun, GL_COMPILE);
  glScalef(0.15f,0.15f,0.15f);
  gluCylinder(quad,0.2,0.2,1.5,50,1);
  glPushMatrix();
  glTranslatef(0.3f,0,1);
  gluCylinder(quad,0.1,0.1,0.5,50,1);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(-0.3f,0,1);
  gluCylinder(quad,0.1,0.1,0.5,50,1);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(-0.3f,0,1);
  glRotatef(90,0,1,0);
  gluCylinder(quad,0.1,0.1,0.7,50,1);
  glPopMatrix();
  glPushMatrix();
  glTranslatef(0.3f,0,1);
  glRotatef(-90,0,1,0);
  gluCylinder(quad,0.1,0.1,0.7,50,1);
  glPopMatrix();
glEndList();

 naboj3 = glGenLists(1);
 glNewList(naboj3, GL_COMPILE);
 glScalef(0.15f,0.15f,0.15f);
 GLUquadricObj* obj7;
 obj7=gluNewQuadric();
 gluCylinder(obj7,0.5,0.5,2,50,1);
 glTranslatef(0,0,2);
 gluCylinder(obj7,0.5,0.01,0.8,50,1);
 glTranslatef(0,0,-2.3f);
 gluCylinder(obj7,0.5,0.01,0.8,50,1);
 glEndList();

  
}

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)
{
	if (height==0)          
	{
		height=1;
	}
    glViewport(0,0,width,height);   
    glMatrixMode(GL_PROJECTION);    
	glLoadIdentity();               
    gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);
    
    glMatrixMode(GL_MODELVIEW);    
	glLoadIdentity();               
}

GLvoid KillGLWindow(GLvoid)
{                          
    if (fullscreen)    
	{                 
		ChangeDisplaySettings(NULL,0); 
		ShowCursor(TRUE);              
	}                                 
	if (hRC)                           
	{
		if (!wglMakeCurrent(NULL,NULL))
		{
			MessageBox(NULL,"Nieudane zwolnienie DC i RC.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		if (!wglDeleteContext(hRC))   
		{
			MessageBox(NULL,"Nieudane usuniecie RC.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;               
	}
	if (hDC && !ReleaseDC(hWnd,hDC))
	{
		MessageBox(NULL,"Nieudane zwolnienie GDI.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;
	}
	if (hWnd && !DestroyWindow(hWnd))
	{
		MessageBox(NULL,"Nie zwolniono handlera.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;
	}

        if (!UnregisterClass("Doom2003",hInstance))
	{                                      
		MessageBox(NULL,"Nie odrejestrowano okna.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;					
	}
}
     
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{       
	GLuint	PixelFormat;    
	HINSTANCE hInstance;      
	WNDCLASS wc;					
	DWORD dwExStyle;	
	DWORD dwStyle;      
    RECT WindowRect;	
	WindowRect.left=(long)0;
	WindowRect.right=(long)width;
	WindowRect.top=(long)0;	
	WindowRect.bottom=(long)height;

	fullscreen=fullscreenflag;
    hInstance=GetModuleHandle(NULL);
	wc.style=CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
                                       
	wc.lpfnWndProc=(WNDPROC) WndProc;
	wc.cbClsExtra=0;               
	wc.cbWndExtra=0;                 
	wc.hInstance=hInstance;
	wc.hIcon=LoadIcon(NULL, IDI_WINLOGO);
	wc.hCursor=LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground=NULL;                 
	wc.lpszMenuName=NULL;                 
	wc.lpszClassName="Doom2003";								
        if (!RegisterClass(&wc))
	{
		MessageBox(NULL,"Blad rejastracji klasy okna!","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE; 											
	}
	if (fullscreen)												
	{
		DEVMODE dmScreenSettings;
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);   
		dmScreenSettings.dmPelsWidth=width;                 
		dmScreenSettings.dmPelsHeight=height;             
		dmScreenSettings.dmBitsPerPel=bits;               
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;
               
        if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			if (MessageBox(NULL,"Karta graficzna nie zadziala w pelnym ekranie.\nCzy uruchomic w oknie?","OpenGL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;
			}
			else
			{
				MessageBox(NULL,"Nastapi wyjscie z programu.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;
			}
		}
	}
    if (fullscreen)												
	{
		dwExStyle=WS_EX_APPWINDOW;							
		dwStyle=WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
		ShowCursor(FALSE);				   
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;
		dwStyle=WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;	
	}       
    AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);
	if (!(hWnd=CreateWindowEx(dwExStyle,"Doom2003",title,dwStyle,0, 0,width, height,
                                  NULL,NULL,hInstance,NULL)))
	{
		KillGLWindow();							
		MessageBox(NULL,"Blad tworzenia okna.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE; 							
	}
    static	PIXELFORMATDESCRIPTOR pfd=
	{
		sizeof(PIXELFORMATDESCRIPTOR),    
		1,                                
		PFD_DRAW_TO_WINDOW |              
		PFD_SUPPORT_OPENGL |              
		PFD_DOUBLEBUFFER,                 
		PFD_TYPE_RGBA,                    
		bits,			  
		0, 0, 0, 0, 0, 0, 
		0,				  
		0,				  
		0,				  
		0, 0, 0, 0,		  
		16,				  
		0,				  
		0,				  
		PFD_MAIN_PLANE,	  
		0,				  
		0, 0, 0			  
	};
		if (!(hDC=GetDC(hWnd)))
	{
		KillGLWindow();								
		MessageBox(NULL,"Nie mozna utworzyc GDI.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

    if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))
	{
		KillGLWindow();								
		MessageBox(NULL,"Nie mozna odnalezc formatu piksli.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}
    if(!SetPixelFormat(hDC,PixelFormat,&pfd))
	{
		KillGLWindow();								
		MessageBox(NULL,"Nie mozna ustawic formatu piksli.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}
    if (!(hRC=wglCreateContext(hDC)))
	{
		KillGLWindow();
		MessageBox(NULL,"Nie mozna podczepic OGL pod GDI.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}
    if(!wglMakeCurrent(hDC,hRC))
	{
		KillGLWindow();								
		MessageBox(NULL,"Nieudana aktywacja RC.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}
    ShowWindow(hWnd,SW_SHOW);
	SetForegroundWindow(hWnd);
	SetFocus(hWnd);		
	ReSizeGLScene(width, height);			
    if (!InitGL())		
	{
		KillGLWindow();								
		MessageBox(NULL,"Blad w procedurze InitGL.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}
        return TRUE;									
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT	uMsg,WPARAM wParam,LPARAM lParam)			
{
	switch (uMsg)                        
	{
		case WM_ACTIVATE:		
		{
			if (!HIWORD(wParam))
			{
				active=TRUE;
			}
			else
			{
				active=FALSE;					
			}
            return 0;								
		}
        case WM_SYSCOMMAND:		
		{
			switch (wParam)							
			{
				case SC_SCREENSAVE:    
				case SC_MONITORPOWER:  
				return 0;	       
			}
			break;									
		}
        case WM_CLOSE:			
		{
			PostQuitMessage(0);						
			return 0;								
		}
        case WM_KEYDOWN:		
		{
			keys[wParam] = TRUE;					
			return 0;								
		}
        case WM_KEYUP:							
		{
			keys[wParam] = FALSE;					
			return 0;								
		}
        case WM_SIZE:							
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  
			return 0;								
		}
	}
    return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)			
{
	MSG msg;
	int i;
	BOOL koniec_programu=FALSE;
	srand( (unsigned)time( NULL ) );
	for(i=0;i<rob_count;i++) {
		health[i]=liczba_trafien;
		rob_direction[i]=(float)(rand()%360);
	}
	xrob[0]=4;
	zrob[0]=4;
	xrob[1]=15;
	zrob[1]=17;
	xrob[2]=45;
	zrob[2]=19;
	xrob[3]=25;
	zrob[3]=18;
	xrob[4]=45;
	zrob[4]=5;
	if (MessageBox(NULL,"Wcisnij TAK na FULLSCREEN, NIE na WINDOW-MODE", "Wybor trybu",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{
		fullscreen=FALSE;							
	}
	if (!CreateGLWindow("Doom2003",800,600,16,fullscreen))
	{
		return 0;									
	}
		przygotuj();
        while(!koniec_programu)									
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
			if (msg.message==WM_QUIT)	 
			{
				koniec_programu=TRUE;							
			}
			else				 
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg); 
			}
		}
		else										
		{
			if ((active && !DrawGLScene()) || keys[VK_ESCAPE])
			{       
				koniec_programu=TRUE;
			}
			else									
			{
				if(czy_koniec()) koniec_programu=true;
				SwapBuffers(hDC);
            
				if (keys[VK_UP]) 
                {
					ruch_w_przod();
                }
                if (keys[VK_DOWN]) 
                {
                ruch_w_tyl();
                }
                if (keys[VK_RIGHT])
				{
					obrot_w_prawo();
				}
                if (keys[VK_LEFT])
				{
					obrot_w_lewo();
				}
				if (keys[VK_SPACE]) 
				{					
					strzal();
					keys[VK_SPACE] = FALSE;
				}
			}
		}
	}
    KillGLWindow();
	if(czy_koniec())
		MessageBox(NULL,"GRATULACJE! WYGRALES!", "INFO",MB_OK);
	return (msg.wParam);						
}
